/*
 * Misc stuff for DaVinci Initial Bootloader.
 *
 * Copyright (c) 2007 Sergey Kubushyn <ksi@koi8.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#ifndef LOADER_H
#define LOADER_H
#include <sys/types.h>

typedef signed char int8_t;
typedef unsigned char u_int8_t;
typedef short int16_t;
typedef unsigned short u_int16_t;
typedef int int32_t;
typedef unsigned int u_int32_t;

#define BOOTCFG			((volatile u_int32_t *)0x01c40014)
#define DV_GPIO_DIR01		((volatile u_int32_t *)0x01c67010)
#define DV_GPIO_SET_DATA01	((volatile u_int32_t *)0x01c67018)
#define DV_GPIO_CLR_DATA01	((volatile u_int32_t *)0x01c6701c)
#define GPIO_MASK(n)		(1 << (n))

extern char __str_buf[64];

void printstr(const char *);
int getstr(void);
char getchr(void);
void putchr(char);
void jump(long);
void load_raw(long addr, long size);

void wait_loop(int);
#endif
